
package de.ivu.elect.business.protokollierung.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.protokollierung.entity.LoeschProtokoll;

@RequestScoped
@Named(LoeschProtokollConversationSelect.COMPONENT_NAME)
public class LoeschProtokollConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "loeschProtokollConversationSelect";

  @Inject
  protected transient LoeschProtokollExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(LoeschProtokollConversationStore.class)
  protected transient LoeschProtokollConversationStore conversationStore;

  public LoeschProtokollConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public LoeschProtokoll getEntity() {
    return getEntityInternal();
  }

  private LoeschProtokoll getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(LoeschProtokoll entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.protokollierung.entity.LoeschProtokollPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(LoeschProtokoll entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.protokollierung.entity.LoeschProtokollPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.protokollierung.entity.LoeschProtokollPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected LoeschProtokoll attach(LoeschProtokoll entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected LoeschProtokoll attach( de.ivu.elect.business.protokollierung.entity.LoeschProtokollPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
